/*  by Enrico Rolfi     */

/* This generic list class is used both with StringItem and CommentItem
 *  classes to store multiple occurences of them sorted in memory.            */ 
                     
template <class T>
class List {
private:
	unsigned short _size;
    unsigned short _last;
          
	T *_item;

public:
    List() : _size(0), _item(0), _last(0) { }

	List(const unsigned short size) : _size(size), _last(0), _item(new T[_size]) { }

	~List();
    
	unsigned short getSize() const { return _size; }
    unsigned short getLast() const { return _last; }
	T *getItem(unsigned short which) const;
	bool addItem(const T *it);
    bool changeItem(const unsigned short which, const T *it);
    bool insertItem(unsigned short loc, const T *it);
};
  
// This method must be declared here for some mysterious reasons
template <class T>  
T *List<T>::getItem(unsigned short which) const 
{
   if (which<_last)
      return &_item[which];
   return 0;  
}

template <class T>  
List<T>::~List()
{
   if (_item)
      delete [] _item;
}

template <class T>
bool List<T>::addItem(const T *it)
{
   if (it && (_last<_size))
   {
      //delete &_item[_last];        
      _item[_last++]=*it;
      return true;
   }
   return false;
}

template <class T>
bool List<T>::changeItem(const unsigned short which, const T *it)
{
   if (which<_last)
   {
      _item[which]=*it;
      return true;
   }   
   return false;
}

template <class T>
bool List<T>::insertItem(unsigned short loc, const T *it)
{
   if (it && (_last<_size))
   {
      //delete &_item[_last];
      for (unsigned short j=_last++; j>loc; j--)
          _item[j]=_item[j-1];

      _item[loc]=*it;  

      return true;
   }
   return false; 
}

