/*  by Enrico Rolfi     */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "list.hpp"
#include "maps.hpp"
#include "ressci.hpp"
#include "lzs.hpp"

//#define _DEBUG
//#define _DEBUGRES
//#define _DEBUGWRES
//#define _DEBUGAUD
//#define _DEBUGWAUD
//#define _DEBUG65535
//#define _DEBUGWSFX

//non si pu ancora usare il numero dei cd da parametri
//quindi supponiamo che non ci siano pi di 15 CD

FILE *scifile[15];    
ResMap *resmaps[15];  
FILE *ressfx[15];  
FILE *resaud[15];  

List<PROGRAMSFXENTRY> *mapsfx;
PMAP65535 newsfxmap;
long itemsc=0;
 
ListAud *mapsaud;
AUDMAP *newaudmaps;

ResMap *newresmap;


char t;
bool isGK2=false;
bool deleteafter=false;
bool DEBUGMODE=false;
int cdnumber=0;
FILE *fileoutput=NULL;

long getUncompRes(void **out, ResMap *map, FILE *vol, unsigned char dir, unsigned short id)
{
     PROGRAMENTRYSCI32 *request = map->getFile(dir, id);
if (DEBUGMODE) { //RES
printf("id %d, paklen %d, unplen %d, offset %d\n",request->id,request->paklen,request->unplen,request->offset);
} //DEBUGMODE
     if (request != NULL)
     {  
        void *uncomp;
        void *comp = new (unsigned char)[request->paklen];
        fseek(vol, request->offset, SEEK_SET);    
        fread(comp, request->paklen, 1, vol);
        if (request->paklen < request->unplen)
        {
           uncomp = new (unsigned char)[request->unplen];
           unsigned long ulen = lzs_unpack(comp, uncomp);
           if (ulen != request->unplen)
           {
              printf("Error unpacking! Expected size %d, unpacked %d", request->unplen, ulen);
              char t = getchar();
           }
           (*out) = uncomp;
           delete [] comp;
           return (long) ulen;
        }
        (*out) = comp;
        delete [] uncomp;
        return (long )request->paklen;    
     }
     (*out) = NULL;
     return -1;
}

int loadDirItems(FILE *mapfile, ResMap *resmap, RESMAPDIRSCI dir, FILE *volfile)
{
    unsigned long oldpos = ftell(mapfile);
    if (!fseek(mapfile, dir.list, SEEK_SET))
    {
       RESMAPIDSSCI32 mapid;
       RESVOLENTRYSCI32 resentry;
       PROGRAMENTRYSCI32 entry;
       
if (DEBUGMODE) { //RES
           printf("dsize %d, type %X\n", resmap->getDirSize(dir.type), dir.type);
} //DEBUGMODE 
       for (unsigned short i=0; i<resmap->getDirSize(dir.type); i++)
       {
           fread(&mapid, RESMAPIDSSCI32SIZE, 1, mapfile);
           fseek(volfile, mapid.offset, SEEK_SET);
           fread(&resentry, RESVOLENTRYSCI32SIZE, 1, volfile);
if (DEBUGMODE) { //RES
           printf("id %d, vol offset %X\n", mapid.id, mapid.offset);
} //DEBUGMODE           
           if ((resentry.type != dir.type) || (resentry.id != mapid.id))
              return -1;
              
           entry.id = resentry.id;
           entry.paklen = resentry.paklen;
           entry.unplen = resentry.unplen;
           entry.pakmeth = resentry.pakmeth;
           entry.file = -1;
           entry.offset = ftell(volfile);   
        
           switch (resmap->addFile(resentry.type, &entry, false, false))
           {
                  case 1:
                       printf("File %d already exists in dir %X", entry.id, dir.type);
                       return -3;
                  case -1:
                       printf("Dir %X not initialized!", dir.type);
                       return -4;
           }
                  
       }
    
    
       fseek(mapfile, oldpos, SEEK_SET);
       return 0;
    }
    return -2;
}

long searchInMapSfx(PMAP65535 entry, List<PROGRAMSFXENTRY> *mapsfx, unsigned short limit)
{
     for (unsigned short i=0; i<limit; i++)
         if ((i == mapsfx->getItem(i)->replaced)
                          &&
             (mapsfx->getItem(i)->number == entry->soundNumber))
             
            return (long) i;
            
     return -1;
}


int loadResMaps()
{
    for (int i=1;i<cdnumber;i++)
    {
        char buf[12];
        sprintf(buf, "RESMAP.%03d", i);
        FILE *mapfile = fopen(buf, "rb");
        if (mapfile == NULL)
        {
           printf("Can't open %s file!\n",buf);
           char t = getchar();
           return -1;
        } 
        sprintf(buf, "RESSCI.%03d", i);
        scifile[i] = fopen(buf, "rb");
        if (scifile[i] == NULL)
        {
           printf("Can't open %s file!\n",buf);
           char t = getchar();
           return -1;
        } 
        
        resmaps[i] = new ResMap;
        
        RESMAPDIRSCI lastdir;
        RESMAPDIRSCI dir;
        
        fread(&lastdir,RESMAPDIRSCISIZE,1,mapfile);
        
        do
        {
          fread(&dir,RESMAPDIRSCISIZE,1,mapfile); 
          resmaps[i]->addDir(lastdir.type, (dir.list-lastdir.list)/RESMAPIDSSCI32SIZE);           
          int err = loadDirItems(mapfile, resmaps[i], lastdir, scifile[i]);
          if (err)
          {
             switch(err)
             {
             case -1:
                  printf("Entry %X in Volume doesn't match Map entry at %X", ftell(scifile[i]), ftell(mapfile));
                  break;
             case -2:
                  printf("Can't load Dir %X at %X!\n",lastdir.type,lastdir.list);
             } 
             char t = getchar();
             return err; 
          }
          
          lastdir = dir;
        } 
        while (dir.type!=0xFF);
        
        unsigned long tvstamp;
        fread(&tvstamp,4,1,mapfile);
        resmaps[i]->VersionStamp(tvstamp);
         
        fclose(mapfile);
        
        if (deleteafter)
        {
           char buf[12];
           sprintf(buf, "RESMAP.%03d", i);
           if (remove(buf)!=0)
              printf("Can't delete %s file!\n",buf);
           else
if (DEBUGMODE) {
              printf("%s file deleted\n",buf);
}           
        } 
        
    }
    return 0;
}

int loadMap65535()
{       
    unsigned short itemsum=0;
    for (int i=1; i<cdnumber; i++)
    {
        PROGRAMENTRYSCI32 *ent = resmaps[i]->getFile(0x10,65535);  //il 65535 potrebbe anche essere esterno(ma in GK2 non lo )
        if (ent == NULL)
        {
           printf("Can't find 65535.map in RESMAP.%03d!\n",i);
           t = getchar();
           return -4;    
        }
        itemsum += ent->unplen/MAP65535SIZE -1;  //CAMBIARE!!!! INAFFIDABILE SE UNCOMPRESS!!!
        //NOTA sul commento precedente, probabilmente ritenevo che in unplen ci fosse 0 se uncompressed
        //dal sorgente di SCIResDump non risulta cos, ma sembra che invece sia unplen=paklen, controllare
    }
    mapsfx = new List<PROGRAMSFXENTRY>(itemsum);
if (DEBUGMODE) { //65535 
    printf("Number of items: %d\n",itemsum);   
    t = getchar();
} //DEBUGMODE    
    for (int i=1; i<cdnumber; i++)
    {
        PMAP65535 tmap;
        long tsize = getUncompRes((void**)&tmap, resmaps[i], scifile[i], 0x10, 65535);
        if (tsize == -1)
        {
           printf("Can't load 65535.map from RESSCI.%03d!\n",i);
           t = getchar();
           return -5;
        }
         
        char buf[12];
        sprintf(buf, "RESSFX.%03d", i);
        FILE *tsfile = fopen(buf, "rb");
        if (tsfile == NULL)
        {
           printf("Can't open %s file!\n",buf);
           t = getchar();
           return -1;
        }
        
        unsigned long curloc = 0;
        unsigned short oldlast = mapsfx->getLast();
        for (unsigned short j=0; j<tsize/MAP65535SIZE-1; j++)
        {
if (DEBUGMODE) { //65535    
    printf("Current 65535.map entry %d from file RESSCI.%03d!\n",tmap[j].soundNumber,i);
} //DEBUGMODE    
            curloc += tmap[j].relOffset;
            
            bool missing = false;
                
            unsigned long checkaud;
            
            fseek(tsfile, 0, SEEK_END);
            if (ftell(tsfile)>curloc)
            {
               fseek(tsfile, curloc, SEEK_SET);
               fread(&checkaud, 4, 1, tsfile);
            }
            else
               checkaud=0;
               
            switch (checkaud)
            {
            case 0x4f530c8d: //'..SO' = SOL format 
            case 0x46464952: //'RIFF' = RIFF/WAV format
                 break;
            default:

                 printf("WARNING! Sound Entry %d from Map 65535 at %d not present in RESSFX.%03d\n",tmap[j].soundNumber,curloc,i);
                 missing = true;
                 break; 
            }
             
            unsigned long esize;
            if (!missing)
            {
               if (j==tsize/MAP65535SIZE-2)   //ultimo elemento
               {   
                   switch (checkaud)
                   {
                   case 0x4f530c8d: //'..SO' = SOL format 
                    
                         fseek(tsfile, curloc+9, SEEK_SET);
                         fread(&esize, 4, 1, tsfile);
                         esize += 14; //da specifiche SOL  
                         break;
                         
                   case 0x46464952: //'RIFF' = RIFF/WAV format
                   
                         fseek(tsfile, curloc+4, SEEK_SET);
                         fread(&esize, 4, 1, tsfile);
                         esize += 8;  
                         break;
                   //default:
                   //      esize = tmap[j+1].relOffset;
                   }
               }
               else
                   esize = tmap[j+1].relOffset;
            }
            else
                  esize = 0;              
                
            
            long twid = searchInMapSfx(&tmap[j],mapsfx,oldlast);
            if (twid != -1)
            {
               PROGRAMSFXENTRY *twin = mapsfx->getItem(twid);
if (DEBUGMODE && (fileoutput == NULL))
{ //65535
               if (esize != twin->size)
               {
                  FILE *sfx1file = fopen("sound1.sfx", "wb");
                  if (sfx1file == NULL)
                  {
                     printf("Can't open sound1.sfx file!\n");
                     t = getchar();
                     return -1;
                  }

                  void *rsound = new (unsigned char)[esize];
                  fseek(tsfile, curloc, SEEK_SET);
                  fread(rsound, esize, 1, tsfile);      
                  fwrite(rsound, esize, 1, sfx1file);

                  delete [] rsound;
                  fclose(sfx1file);


                  FILE *sfx2file = fopen("sound2.sfx", "wb");
                  if (sfx2file == NULL)
                  {
                     printf("Can't open sound2.sfx file!\n");
                     t = getchar();
                     return -1;
                  }
                  
                  char buf[12];
                  sprintf(buf, "RESSFX.%03d", twin->file);
                  FILE *tsfxfile = fopen(buf, "rb");
                  if (tsfxfile == NULL)
                  {
                     printf("Can't open %s file!\n",buf);
                     t = getchar();
                     return -1;
                  }
                  
                  rsound = new (unsigned char)[twin->size];
                  fseek(tsfxfile, twin->offset, SEEK_SET);
                  fread(rsound, twin->size, 1, tsfxfile);      
                  fwrite(rsound, twin->size, 1, sfx2file);

                  delete [] rsound;
                  fclose(sfx2file);
                  fclose(tsfxfile);
               

                  printf("\n\nSound entry %d of size %d at loc %d in file RESSFX.%03d already exists with size %d at loc %d in file RESSFX.%03d!\n",tmap[j].soundNumber,esize,curloc,i,twin->size,twin->offset,twin->file);
                  printf("Please listen to both and choose which one should be saved.\n");
                  printf("A copy of both has been saved in the program folder (sound1.sfx,sound2.sfx).\n");
                  
                  printf("\nType 1 to save sound1.sfx or 2 to save sound2.sfx. Any other key to let the program decide:\n");
                  char tf = getchar();
                  
                  
                  switch(tf)
                  {
                   case '1':
                   {
                     twin->replaced = mapsfx->getLast();
                     
                     mapsfx->changeItem(twid, twin); 
                     twid = mapsfx->getLast();         //the new one is better                 
                     break;
                   }
                   case '2':
                        break;
                   default:
                        goto here; 
                   }
                  
               }
               else
                   printf("Duplicated sound entry %d in file RESSFX.%03d and in file RESSFX.%03d!\n",tmap[j].soundNumber,twin->file,i);                                           



} //DEBUGMODE               
else
here:           
               if (esize > twin->size)
               {                  
                  if ((!isGK2) || (twin->number!=801))
                  {
if (DEBUGMODE) { //65535    
                  printf("Replaced Sound entry %d of size %d at loc %d in file RESSFX.%03d with entry of size %d at loc %d in file RESSFX.%03d!\n",tmap[j].soundNumber,twin->size,twin->offset,twin->file,esize,curloc,i);
} //DEBUGMODE
                     twin->replaced = mapsfx->getLast();
                     
                     mapsfx->changeItem(twid, twin); 
                     twid = mapsfx->getLast();         //the new one is better
                  }
                  else
if (DEBUGMODE) { //65535
               
                   printf("Discarded Sound entry %d of size %d in file RESSFX.%03d because of GK2 switch. The correct one is entry of size %d in file RESSFX.%03d!\n",tmap[j].soundNumber,twin->size,twin->file,esize,i);                                           
} //DEBUGMODE

               } else
if (DEBUGMODE) { //65535
               
                   printf("Not replaced Sound entry %d of size %d in file RESSFX.%03d with entry of size %d in file RESSFX.%03d!\n",tmap[j].soundNumber,twin->size,twin->file,esize,i);                                           
} //DEBUGMODE

            } else
                  twid = mapsfx->getLast();          //the new one is better
             
            
            PROGRAMSFXENTRY tpentry;
            tpentry.number=tmap[j].soundNumber;
            tpentry.size=esize;
            tpentry.file=i;
            tpentry.offset=curloc;
            tpentry.replaced=twid;
            mapsfx->addItem(&tpentry);
            
            oldlast = mapsfx->getLast();    
        }
        
        fclose(tsfile);
        delete [] tmap;
    }

    return 0;
}

int loadAudMaps()
{
    unsigned short itemsum=0;
    for (int i=1; i<cdnumber; i++)
        itemsum += resmaps[i]->getDirItemsCount(0x10);        //More than actually needed considering that there are duplicates
        
    mapsaud = new ListAud(itemsum);
    
    unsigned long overcounter=0;
    unsigned long rightcounter=0;
if (DEBUGMODE) { //AUD
    printf("Total map file number: %d\n",itemsum);
    
} //DEBUGMODE    
    
    for (int i=1; i<cdnumber; i++)
    {
        char buf[12];
        sprintf(buf, "RESAUD.%03d", i);
        FILE *tsfile = fopen(buf, "rb");
        if (tsfile == NULL)
        {
           printf("Can't open %s file!\n",buf);
           char t = getchar();
           return -1;
        }
        
        for (unsigned short j=0; j<resmaps[i]->getDirItemsCount(0x10); j++)
        {  
            PROGRAMENTRYSCI32 *ent = resmaps[i]->getFileByNum(0x10,j);
if (DEBUGMODE) { //AUD
            printf("Map file %d, offset %d in RESSCI.%03d\n",ent->id,ent->offset,i);
} //DEBUGMODE
            if (ent == NULL)
            {
               printf("Can't find audio map idx%d from RESSCI.%03d!", j, i);
               char t = getchar();
               return -6;
            }
            if (ent->id == 65535)
               continue;
               
            unsigned short itemscount = (ent->unplen -4-11)/MAPSAUDSIZE;  //CONTROLLARE SE VA BENE GLI 11 xFF
            //andrebbero calcolati a priori il numero di elementi TOTALE di TUTTI i file che si chiamano
            // per esempio 202.map!!! la classe List non  dinamica!!! 
            //renderla dinamica con reallocazione oppure fissare una cardinalit molto alta o empirica!!!
            //MA PER ORA fissiamo una cardinalit fissa di 1000,
            //(tanto se va in overflow ce lo segnala il check della classe list)
            
            
            //vediamo prima se esiste gi la mappa:
            ProgramAudMap *tAudMap = mapsaud->getAudFile(ent->id);
            if (tAudMap == 0)
            {
                tAudMap = new ProgramAudMap(ent->id, 1000);
                
                unsigned short pos=0;
                if (mapsaud->getItem(0)!=0)
                {
                   ProgramAudMap *curitem = *mapsaud->getItem(0);
                   ProgramAudMap *lastitem = curitem;
                   if (curitem->getAudFileNumber() < ent->id)
                      for (pos=1; pos<mapsaud->getLast(); pos++)
                      {
                          curitem = *mapsaud->getItem(pos);
                          if ((curitem->getAudFileNumber() > ent->id)
                                            &&
                             (lastitem->getAudFileNumber() < ent->id))
                          
                             break;
                
                 
                          lastitem = curitem;  
                      }
                }
    
                if (!mapsaud->insertItem(pos,&tAudMap))
                {
                  printf("Overbound on audio %d.map array from RESSCI.%03d (more than 1000 items??)!", ent->id, i);
                  char t = getchar();
                  return -7;   
                }
            }
            
            PMAPSAUD tmap;
            long tsize = getUncompRes((void**)&tmap, resmaps[i], scifile[i], 0x10, ent->id);
            if (tsize == -1)
            {
               printf("Can't load or uncompress %d.map from RESSCI.%03d!\n",ent->id, i);   //CAMBIARE1!!!1
               char t = getchar();
               return -5;
            }
            
            if ((tsize-4-11)/MAPSAUDSIZE != itemscount)
            {
               printf("Audio %d.map file in RESSCI.%03d doesn't match entry in RESMAP.%03d!!", ent->id,i,i);   //CAMBIARE1!!!1
               char t = getchar();
               return -8; 
            }
            
            unsigned long curloc = ((unsigned long *)tmap)[0];
            tmap = (PMAPSAUD)(((unsigned long)tmap) +4);
            for (int z=0; z<itemscount; z++)
            {
               curloc += tmap[z].relOffset;
               unsigned long esize;
               
                //VERIFICHIAMO prima se esiste realmente...
               
               unsigned long checkaud;
               fseek(tsfile, 0, SEEK_END);
               if (ftell(tsfile)>curloc)
               {
                  fseek(tsfile, curloc, SEEK_SET);
                  fread(&checkaud, 4, 1, tsfile);
               }               
               else
                  checkaud=0;
               
               if (z == itemscount-1)   //ultimo elemento
               {
                 //QUANDO FACCIO QUESTO, VA RICORDATO CHE IN GK2ITA C'E' UN ERRORE
               //IL FILE 20.MAP non  stato "TRADOTTO"
                   switch (checkaud)
                   {
                   case 0x4f530c8d: //'..SO' = SOL format 
                    
                         fseek(tsfile, curloc+9, SEEK_SET);
                         fread(&esize, 4, 1, tsfile);
                         esize += 14; //da specifiche SOL  
                         break;
                         
                   case 0x46464952: //'RIFF' = RIFF/WAV format
                   
                         fseek(tsfile, curloc+4, SEEK_SET);
                         fread(&esize, 4, 1, tsfile);
                         esize += 8;  
                         break;
                   //default:
                   //      esize = tmap[z+1].relOffset;
                   }
               }
               else
                  esize = tmap[z+1].relOffset;
            

               PROGRAMAUDENTRY tpentry;
               tpentry.number=tmap[z].audNumber;
               tpentry.size=esize;
               tpentry.file=i;
               tpentry.offset=curloc;

              
               
               switch (checkaud)
               {
               case 0x4f530c8d: //'..SO' = SOL format 
               case 0x46464952: //'RIFF' = RIFF/WAV format
                    {
                        int tdebug=0;
                               
                        if (DEBUGMODE && (fileoutput == NULL))
                        {
                          long tmpTwinIdx = tAudMap->searchAud(tpentry.number);
                          if (tmpTwinIdx>=0)
                          {  
                             PROGRAMAUDENTRY *tmpTwin=tAudMap->getAudEntryByNum(tmpTwinIdx);
                             if (tmpTwin->size!=tpentry.size)
                             {

                                FILE *sfx1file = fopen("voice1.aud", "wb");
                                if (sfx1file == NULL)
                                {
                                   printf("Can't open voice1.aud file!\n");
                                   t = getchar();
                                   return -1;
                                }
                                void *rsound = new (unsigned char)[tpentry.size];
                                fseek(tsfile, tpentry.offset, SEEK_SET);
                                fread(rsound, tpentry.size, 1, tsfile);      
                                fwrite(rsound, tpentry.size, 1, sfx1file);

                                delete [] rsound;
                                fclose(sfx1file);


                                FILE *sfx2file = fopen("voice2.aud", "wb");
                                if (sfx2file == NULL)
                                {
                                   printf("Can't open voice2.aud file!\n");
                                   t = getchar();
                                   return -1;
                                }
                  
                                char buf[12];
                                sprintf(buf, "RESAUD.%03d", tmpTwin->file);
                                FILE *taudfile = fopen(buf, "rb");
                                if (taudfile == NULL)
                                {
                                   printf("Can't open %s file!\n",buf);
                                   t = getchar();
                                   return -1;
                                }
                                rsound = new (unsigned char)[tmpTwin->size];
                                fseek(taudfile, tmpTwin->offset, SEEK_SET);
                                fread(rsound, tmpTwin->size, 1, taudfile);      
                                fwrite(rsound, tmpTwin->size, 1, sfx2file);

                                delete [] rsound;
                                fclose(sfx2file);
                                fclose(taudfile);
               

                                printf("\n\nAudio entry %d of size %d at loc %d in file RESAUD.%03d already exists with size %d at loc %d in file RESAUD.%03d!\n",tpentry.number,tpentry.size,tpentry.offset,tpentry.file,tmpTwin->size,tmpTwin->offset,tmpTwin->file);
                                printf("Please listen to both and choose which one should be saved.\n");
                                printf("A copy of both has been saved in the program folder (voice1.aud,voice2.aud).\n");
                                char tf;

                                printf("\nType 1 to save voice1.aud or 2 to save voice2.aud. Any other key to let the program decide:\n");
                                tf = getchar();
                                
                          
                                switch(tf)
                                {
                                 case '1':
                                   tdebug=1;
                                   break;
                                 case '2':
                                   tdebug=2;
                                   break;
                                 default:
                                   tdebug=0;
                                }
                             }
                    
                          }
                          
                        }
                        
                        long tvalue = tAudMap->addAudEntry(&tpentry, tdebug);
                        switch (tvalue)
                        {
                        case -1:
                             {
                                printf("Can't add audio Entry %X from Map %d in RESAUD.%03d!\n",tpentry.number,ent->id,i);
                                char t = getchar();
                                return -1;
                             }     
                        case 1:
                    
if (DEBUGMODE) { //AUD
                             
                             {
                               overcounter+= tpentry.size;
                               
                               PROGRAMAUDENTRY *debentry = tAudMap->getAudEntry(tpentry.number);
                               if (tpentry.size!=debentry->size)
                                  printf("Aud Entry %X of size %d from Map %d in loc %d of RESAUD.%03d already exists at loc %d in RESAUD.%03d with size %d\n",tpentry.number,tpentry.size,ent->id,tpentry.offset,i,debentry->offset,debentry->file,debentry->size);
                               else    
                                  printf("Audio Entry %X from Map %d in RESAUD.%03d already exists\n",tpentry.number,ent->id,i); 
                             }
} //DEBUGMODE
                    
                             break;
                        case 0:
if (DEBUGMODE) { //AUD
                             rightcounter+=tpentry.size;
                             printf("Inserted Audio Entry %X of size %d from Map %d at %d in RESAUD.%03d\n",tpentry.number,tpentry.size,ent->id,tpentry.offset,i);
} //DEBUGMODE
                             break;
                        default:
if (DEBUGMODE) { //AUD
                             rightcounter+= (tpentry.size-tvalue);
                             overcounter+= tvalue;
                             printf("Replaced Aud Entry %d of size %d with new one of size %d from Map %d in loc %d of RESAUD.%03d\n",tvalue,tpentry.number,tpentry.size,ent->id,tpentry.offset,i);
} //DEBUGMODE
                             break;
                        }
                 
                    }
                    break;
                         
                    default:
if (DEBUGMODE) { //AUD
                    printf("Skipped Audio Entry %X from Map %d at %d not present in RESAUD.%03d\n",tpentry.number,ent->id,tpentry.offset,i);
} //DEBUGMODE
                    break;     
                    
               }       
            }
            
            delete [] tmap;  
        }
        
        fclose(tsfile);
    } 
if (DEBUGMODE) { //AUD
                       printf("Bytes saved: %d\n",rightcounter);
                         printf("Bytes skipped: %d\n",overcounter);
} //DEBUGMODE   
                        
    return 0;                         
}           


int buildRESSFX()
{
if (DEBUGMODE) { //WSFX
printf("Number of sfx items: %d\n",mapsfx->getLast());
t = getchar();
} //DEBUGMODE

//NOTA forse prima di costruire andrebbero riordinati
//anche se gli originali non lo sono per nulla
    itemsc=0;
    PROGRAMSFXENTRY *titemp;
    for (long i=0; i<mapsfx->getLast(); i++)
    {
        titemp = mapsfx->getItem(i);
if (DEBUGMODE) { //WSFX
printf("Counter: %d, Replaced: %d \n",i,titemp->replaced);

} //DEBUGMODE

        if ((i == titemp->replaced) && (titemp->size >0))
           itemsc++; 
    }
    
if (DEBUGMODE) { //WSFX
printf("Number of valid items: %d\n",itemsc);
t = getchar();
} //DEBUGMODE

     // stabilire a priori quanti sono (cio quanti replaced==id)
    // e portarsi appresso un contatore di riempimento
    newsfxmap = new MAP65535 [itemsc+1]; //c' anche l'elemento nullo FFFFFFFFF 
    
    
    for (int i=1; i<cdnumber; i++) 
    {
        char buf[12];
        sprintf(buf, "RESSFX.%03d", i);
        ressfx[i] = fopen(buf, "rb");
        if (ressfx[i] == NULL)
        {
           printf("Can't open %s file!\n",buf);
           t = getchar();
           return -1;
        }
    }
    
    FILE *newsfxfile = fopen("RESOURCE.SFX", "wb");
    if (newsfxfile == NULL)
    {
       printf("Can't create RESOURCE.SFX file!\n");
       char t = getchar();
       return -1;
    }
    
    unsigned long curitem = 0;
    unsigned long lastsize = 0; //ATTn!! dovrebbe essere :24!!!!1
    for (unsigned long i=0; i<mapsfx->getLast(); i++)
    {
        titemp = mapsfx->getItem(i);
        if ((i == titemp->replaced) && (titemp->size >0))
        {
if (DEBUGMODE) { //WSFX
printf("Processing entry: %d at %X of size %d in RESSFX.%03d\n",titemp->number, titemp->offset, titemp->size, titemp->file);
} //DEBUGMODE 
           //leggiamo il file originale
           void *rsound = new (unsigned char)[titemp->size];
           fseek(ressfx[titemp->file], titemp->offset, SEEK_SET);
           fread(rsound, titemp->size, 1, ressfx[titemp->file]);      
          
           //creiamo l'elemento nella mappa
           newsfxmap[curitem].soundNumber=titemp->number;
           newsfxmap[curitem].relOffset=lastsize;
if (DEBUGMODE) { //WSFX
printf("Added map entry: number %d relOffs %X\n",newsfxmap[curitem].soundNumber, newsfxmap[curitem].relOffset);
} //DEBUGMODE            
           lastsize = titemp->size; //ATTn!! dovrebbe essere :24!!!!1
           
           //scriviamo il nuovo file
           if (fwrite(rsound, titemp->size, 1, newsfxfile) == 0)
           {
              printf("Error when writing RESOURCE.SFX file!\n");
              char t = getchar();
              return -1;      //cambiare
           }
if (DEBUGMODE) { //WSFX
printf("RES.SFX file location: %X\n", ftell(newsfxfile));
} //DEBUGMODE           
           delete [] rsound;
                 
           curitem++;          
        }          
    }
    
    newsfxmap[itemsc].soundNumber=0xFFFF;
    newsfxmap[itemsc].relOffset=0xFFFFFF;
    

    for (int i=1; i<cdnumber; i++) 
    {
        fclose(ressfx[i]);
        
        if (deleteafter)
        {
           char buf[12];
           sprintf(buf, "RESSFX.%03d", i);
           if (remove(buf)!=0)
              printf("Can't delete %s file!\n",buf);
           else
if (DEBUGMODE) {
              printf("%s file deleted\n",buf);
}           
        } 
        
    }
    
    fclose(newsfxfile);
    return 0;
}


int buildRESAUD()
{

    for (int i=1; i<cdnumber; i++) 
    {
        char buf[12];
        sprintf(buf, "RESAUD.%03d", i);
        resaud[i] = fopen(buf, "rb");
        if (resaud[i] == NULL)
        {
           printf("Can't open %s file!\n",buf);
           t = getchar();
           return -1;
        }
    }
    
    FILE *newaudfile = fopen("RESOURCE.AUD", "wb");
    if (newaudfile == NULL)
    {
       printf("Can't create RESOURCE.AUD file!\n");
       char t = getchar();
       return -1;
    }

    newaudmaps = new AUDMAP [mapsaud->getLast()]; 
if (DEBUGMODE) { //WAUD
printf("Number of map files: %d\n", mapsaud->getLast());
} //DEBUGMODE       
    
    for (int i=0; i<mapsaud->getLast(); i++)
    {
        ProgramAudMap *titem = *(mapsaud->getItem(i));
        unsigned short entriescount = titem->getEntriesCount();
        newaudmaps[i].entry = new MAPSAUD [entriescount];
        newaudmaps[i].fileNumber = titem->getAudFileNumber();
        newaudmaps[i].fileStart = ftell(newaudfile);   //TROVARE SOLUZIONE migliore?
        newaudmaps[i].entriesCount= entriescount;
if (DEBUGMODE) { //WAUD
printf("Processing map file: %d with %d entries\n", newaudmaps[i].fileNumber, entriescount);
} //DEBUGMODE 
        unsigned long lastsize = 0;
        for (long j=0; j<entriescount; j++)
        {
            PROGRAMAUDENTRY *tentry = titem->getAudEntryByNum(j);
            newaudmaps[i].entry[j].audNumber = tentry->number;
            newaudmaps[i].entry[j].relOffset = lastsize; //ATTN deve essere 3 byte!!!
if (DEBUGMODE) { //WAUD
printf("Entry %X of map file: %d\n", newaudmaps[i].entry[j].audNumber,newaudmaps[i].fileNumber);
} //DEBUGMODE       
            
            if (tentry->size > 0)
            {
               //leggiamo il file originale
               void *rsound = new (unsigned char)[tentry->size];
               fseek(resaud[tentry->file], tentry->offset, SEEK_SET);
               fread(rsound, tentry->size, 1, resaud[tentry->file]);      

               //scriviamo il nuovo file
               if (fwrite(rsound, tentry->size, 1, newaudfile) == 0)
               {
                  printf("Error when writing RESOURCE.AUD file!\n");
                  char t = getchar();
                  return -1; 
               }
               
               delete [] rsound;
            }
            else
            {
if (DEBUGMODE) { //WAUD
printf("Skipped 0-sized Entry %X of map file: %d\n", newaudmaps[i].entry[j].audNumber,newaudmaps[i].fileNumber);
} //DEBUGMODE    
            
            }


            lastsize=tentry->size;
                       
        }
    
        //QUI ANDREBBERO AGGIUNTI GLI FFFFFFF ma non si pu farlo qui 
        //quindi lo facciamo pi avanti quando lo scriviamo nel resource
    
    }

    for (int i=1; i<cdnumber; i++) 
    {
        fclose(resaud[i]);
        
        if (deleteafter)
        {
           char buf[12];
           sprintf(buf, "RESAUD.%03d", i);
           if (remove(buf)!=0)
              printf("Can't delete %s file!\n",buf);
           else
if (DEBUGMODE) {
              printf("%s file deleted\n",buf);
}           
        } 
        
    }
    
    fclose(newaudfile);
    
    return 0;
}

int buildResource()
{

//if (DEBUGMODE) { //WRES

    unsigned long crazycounter=0;
//} //DEBUGMODE
    newresmap = new ResMap;
    newresmap->VersionStamp(resmaps[1]->VersionStamp());

    
    //determiniamo la grandezza massima in eccesso delle directory e init
    for (char j=0; j<32; j++)
        if (j!=0x10)   //to skip sound .MAP
        {    
             unsigned short tdirsize = 0;
        
             for (int i=1; i<cdnumber; i++)     
                 tdirsize += resmaps[i]->getDirItemsCount(j);
        
             newresmap->addDir(j,tdirsize);          
        }
        else
        {
        //immettiamo per ora solo la grandezza della dir dei MAP:  
           newresmap->addDir(0x10,mapsaud->getLast()+1); //+1 perch c' anche 65535  
        }
    
    //scegliamo quali file inserire e quali no:   
    for (int i=1; i<cdnumber; i++)                     
        for (char j=0; j<32; j++)
        {
            if (j!=0x10)       //to skip sound .MAP
               for (unsigned short z=0; z<resmaps[i]->getDirItemsCount(j); z++)
               {
                  PROGRAMENTRYSCI32 *tpentry = resmaps[i]->getFileByNum(j,z);
                  PROGRAMENTRYSCI32 *ttwin = newresmap->getFile(j,tpentry->id);   
                  PROGRAMENTRYSCI32 newentry = *tpentry;
                  //memcpy(&newentry, tpentry, sizeof(PROGRAMENTRYSCI32));
                  newentry.file = i;
                  
                  if (ttwin != NULL)
                  {
                     if (ttwin->unplen > tpentry->unplen)
                     {
if (DEBUGMODE) { //WRES
                        printf("Skipped File %d of dir %X with size %d from file RESSCI.%03d already exists with size %d!\n",tpentry->id,j,tpentry->unplen,i,ttwin->unplen);
} //DEBUGMODE
                         
                     }
                     else if (ttwin->unplen == tpentry->unplen)
                     {
if (DEBUGMODE) { //WRES
                        printf("File %d of dir %X with size %d from file RESSCI.%03d already exists!\n",tpentry->id,j,tpentry->unplen,i,ttwin->unplen);
} //DEBUGMODE                     
                     } 
                     else
                     {
if (DEBUGMODE) { //WRES
                        printf("New file %d of dir %X with size %d from file RESSCI.%03d replaced old one with size %d from file RESSCI.%03d!\n",tpentry->id,j,tpentry->unplen,i,ttwin->unplen,ttwin->file);
                        crazycounter+=tpentry->paklen -ttwin->paklen;
} //DEBUGMODE                   
                        newresmap->addFile(j,&newentry, true, false);   
                     
                     }
                  }
                  else
                  {    
if (DEBUGMODE) { //WRES
                        printf("Added file %d of dir %X with size %d from file RESSCI.%03d.\n",tpentry->id,j,tpentry->unplen,i);
                        crazycounter+=tpentry->paklen;
} //DEBUGMODE   
                      newresmap->addFile(j,&newentry, false, true);
                  }
                  
               }
        }
         
if (DEBUGMODE) { //WRES
    printf("Number of bytes: %d!\n", crazycounter);
    t = getchar();
} //DEBUGMODE  
  

    //cominciamo a scrivere i file:
    
    FILE *newresfile = fopen("RESSCI.000", "wb");
    if (newresfile == NULL)
    {
       printf("Can't create RESSCI.000 file!\n");
       t = getchar();
       return -1;
    }
    
    FILE *newmapfile = fopen("RESMAP.000", "wb");
    if (newmapfile == NULL)
    {
       printf("Can't create RESMAP.000 file!\n");
       t = getchar();
       return -1;
    }
    
    
if (DEBUGMODE) { //WRES
    printf("Checkpoint 1\n");
    t = getchar();
} //DEBUGMODE     
    
    unsigned short dirloc=(newresmap->getDirCount()+1)* 3 + 4; //3byte pi FF + il VersionStamp
    for (char i=0; i<32; i++)
        if (newresmap->getDirSize(i)>0)
        {   
            RESMAPDIRSCI tmapdir;
            tmapdir.type=i;
            tmapdir.list=dirloc; 
if (DEBUGMODE) { //WRES
    printf("Current Dir = %X, offset %d\n",tmapdir.type,tmapdir.list);
    t = getchar();
} //DEBUGMODE  
            if (fwrite(&tmapdir, RESMAPDIRSCISIZE, 1, newmapfile) == 0)
            {
               printf("Error when writing RESMAP.000 file!\n");
               t = getchar();
               return -1;
            }                     
           
            if (i!=0x10)
               dirloc += (newresmap->getDirItemsCount(i)*RESMAPIDSSCI32SIZE);   
            else
               dirloc += ((mapsaud->getLast()+1)*RESMAPIDSSCI32SIZE);
    
        }
if (DEBUGMODE) { //WRES
    printf("Checkpoint 2\n");
    t = getchar();
} //DEBUGMODE          
    
    RESMAPDIRSCI tmapdir;
    tmapdir.type=0xFF;
    tmapdir.list=dirloc; 
    if (fwrite(&tmapdir, RESMAPDIRSCISIZE, 1, newmapfile) == 0)
    {
        printf("Error when writing RESMAP.000 file!\n");
        t = getchar();
        return -1;
    } 
                   
    unsigned long tverst = newresmap->VersionStamp();    
    if (fwrite(&tverst, 4, 1, newmapfile) == 0)
    {
        printf("Error when writing RESMAP.000 file!\n");
        t = getchar();
        return -1;
    }
if (DEBUGMODE) { //WRES
    printf("Checkpoint 3\n");
    t = getchar();
} //DEBUGMODE  
    //ora cominciamo a scrivere le voci delle directory dalla prima:
    unsigned long resloc = 0;
    
    for (char i=0; i<32; i++)
    {
        if (i!=0x10)
           for (unsigned short j=0; j<newresmap->getDirItemsCount(i); j++)    
           {
           
               PROGRAMENTRYSCI32 *tpentry=newresmap->getFileByNum(i,j);
               RESMAPIDSSCI32 tmapid;
                 
               tmapid.id=tpentry->id;
               tmapid.offset=resloc;
               
               if (fwrite(&tmapid, RESMAPIDSSCI32SIZE, 1, newmapfile) == 0)
               {
                  printf("Error when writing RESMAP.000 file!\n");
                  t = getchar();
                  return -1;
               } 
if (DEBUGMODE) { //WRES
    printf("Just wrote in RESMAP.000: %d at loc %d\n",tmapid.id,tmapid.offset);
} //DEBUGMODE                 
               
               RESVOLENTRYSCI32 tresvol;
               tresvol.type=i;
               tresvol.id=tpentry->id;
               tresvol.paklen=tpentry->paklen;
               tresvol.unplen=tpentry->unplen;
               tresvol.pakmeth=tpentry->pakmeth;
                   
               if (fwrite(&tresvol, RESVOLENTRYSCI32SIZE, 1, newresfile) == 0)
               {
                  printf("Error when writing RESSCI.000 file!\n");
                  t = getchar();
                  return -1;
               }
               
               //leggiamo il file originale
               void *rdata = new (unsigned char)[tpentry->paklen];
               fseek(scifile[tpentry->file], tpentry->offset, SEEK_SET);
               fread(rdata, tpentry->paklen, 1, scifile[tpentry->file]);      

               //scriviamo il nuovo file
               if (fwrite(rdata, tpentry->paklen, 1, newresfile) == 0)
               {   
                  printf("Error when writing RESSCI.000 file!\n");
                  t = getchar();
                  delete [] rdata;
                  return -1;
               }
if (DEBUGMODE) { //WRES
    printf("Just wrote in in RESSCI.000 file\n");
} //DEBUGMODE               
               delete [] rdata;
               
               resloc += tpentry->paklen + RESVOLENTRYSCI32SIZE;
               //----oppure
               //---resloc = ftell  
           }
        else  //dir==0x10
        {   
        //scriviamo tutti i map del res aud
           for (unsigned short j=0; j<mapsaud->getLast(); j++)    
           {
               AUDMAP taudmap=newaudmaps[j];
               RESMAPIDSSCI32 tmapid;
                 
               tmapid.id=taudmap.fileNumber;
               tmapid.offset=resloc;
               
               if (fwrite(&tmapid, RESMAPIDSSCI32SIZE, 1, newmapfile) == 0)
               {
                  printf("Error when writing RESMAP.000 file!\n");
                  t = getchar();
                  return -1;
               } 
               
               
               RESVOLENTRYSCI32 tresvol;
               tresvol.type=0x10;
               tresvol.id=taudmap.fileNumber;
               tresvol.paklen=taudmap.entriesCount*MAPSAUDSIZE +4+11; //filestart + fffffff
               tresvol.unplen=tresvol.paklen;
               tresvol.pakmeth=0;
                   
               if (fwrite(&tresvol, RESVOLENTRYSCI32SIZE, 1, newresfile) == 0)
               {
                  printf("Error when writing RESSCI.000 file!\n");
                  t = getchar();
                  return -1;
               }
               

               //scriviamo il nuovo file
               if (fwrite(&taudmap.fileStart, 4, 1, newresfile) == 0)
               {   
                  printf("Error when writing RESSCI.000 file!\n");
                  t = getchar();
                  return -1;
               }
            
               if (fwrite(taudmap.entry, MAPSAUDSIZE, taudmap.entriesCount, newresfile) < taudmap.entriesCount)
               {   
                  printf("Error when writing RESSCI.000 file!\n");
                  t = getchar();
                  return -1;
               }
               
               char tempff= -1;
               for (int ff=0; ff<11; ff++)
                   if (fwrite(&tempff, 1, 1, newresfile) == 0)
                   {   
                       printf("Error when writing RESSCI.000 file!\n");
                       t = getchar();
                       return -1;
                   }
               
               resloc += (tresvol.paklen) + RESVOLENTRYSCI32SIZE;
           }
           
           //adesso scriviamo per ultimo il 65535.map
           
           RESMAPIDSSCI32 tmapid;
                 
           tmapid.id=65535;
           tmapid.offset=resloc;
           
           if (fwrite(&tmapid, RESMAPIDSSCI32SIZE, 1, newmapfile) == 0)
           {
              printf("Error when writing RESMAP.000 file!\n");
              t = getchar();
              return -1;
           } 
               
               
           RESVOLENTRYSCI32 tresvol;
           tresvol.type=0x10;
           tresvol.id=65535;
           tresvol.paklen=(itemsc+1)*MAP65535SIZE;
           tresvol.unplen=tresvol.paklen;
           tresvol.pakmeth=0;
                   
           if (fwrite(&tresvol, RESVOLENTRYSCI32SIZE, 1, newresfile) == 0)
           {
              printf("Error when writing RESSCI.000 file!\n");
              t = getchar();
              return -1;
           }
           
           if (fwrite(newsfxmap, MAP65535SIZE, itemsc+1, newresfile) < itemsc+1)
           {   
              printf("Error when writing RESSCI.000 file!\n");
              t = getchar();
              return -1;
           }
           
           resloc += (tresvol.paklen) + RESVOLENTRYSCI32SIZE;
        }
        
        
    }


    for (int i=1; i<cdnumber; i++) 
    {
        fclose(scifile[i]);
        
        if (deleteafter)
        {
           char buf[12];
           sprintf(buf, "RESSCI.%03d", i);
           if (remove(buf)!=0)
              printf("Can't delete %s file!\n",buf);
           else
if (DEBUGMODE) {
              printf("%s file deleted\n",buf);
}           
        } 
        
    }
    
    fclose(newresfile);
    fclose(newmapfile);
        
    return 0;
}


int main(int argc, char* argv[])
{
   
    //NOTA: si presuppone per semplicita che il programma 
    //abbia gi tutti i file presenti nella sua cartella
    //copiati da cd e si assume che i resource sfx e aud siano
    //chiamati RESSFX.00x e RESAUD.00x 
    
    //TODO ricordarsi dei file patches sfusi nel CD!
    //dovrebbe bastare ricopiarli, al massimo potrei sprecarmi a sostituirli nel RESSCI
  
    printf("\nUniSCI v1.0 - Game files Joiner for SCI32 CDROM games\n");
    printf("              (c)Enrico Rolfi(Endroz), Dec 2004.\n\n");
    
    for (int i=0; i<argc; i++)   
        if (
                  !strcmp("-h", argv[i])
               || !strcmp("-?", argv[i])
               || !strcmp("/h", argv[i])
               || !strcmp("/?", argv[i])
               || !strcmp("help", argv[i])
               || !strcmp("?", argv[i])
           )
        {
		      printf("? Usage: unisci [-n:<CDs>] [-gk2] [-del] [-out:file>]\n\n");
              printf("  The files to join must be located in the same directory of scijoin\n");
              printf("  They must have the following names:\n");
              printf("  - RESMAP.00x and RESSCI.00x\n");
              printf("  - RESOURCE.AUD files must be renamed RESAUD.00x\n");
              printf("  - RESOURCE.SFX files must be renamed RESSFX.00x\n");
              printf("  where <x> is the number of the corresponding CD\n\n");
              printf("  Parameters:\n");
              printf("    [-n:<CDs>] Number of segments to join (CDs number)\n");
              printf("        [-gk2] Apply special patches for Gabriel Knight 2\n");
              printf("        [-del] Delete original files if join succeeds\n");
              printf("      [-debug] Activates debug informations (only use in case of errors)\n");
              printf(" [-out:<file>] Optional output on text file, must specify a name\n");                                                      
        
		      return -1;
        }
   
     printf("\n\n Please Wait......................\n\n");

  
    for (int i=0; i<argc; i++)
    {    
        if (!strcmp("-gk2", argv[i]))
           isGK2 = true; 
        if (!strncmp("-n:", argv[i], 3))
           cdnumber=atoi((argv[i]+3))+1;
        if (!strcmp("-del", argv[i]))
           deleteafter = true;
        if (!strcmp("-debug", argv[i]))
           DEBUGMODE = true; 
        if (!strncmp("-out:", argv[i], 5))
        {
           fclose(stdin);
           fileoutput=freopen((argv[i]+5),"w",stdout); 
        }                         
    }       	
    
    if (!cdnumber)
    {
       FILE *tfile = NULL;
       cdnumber=0;
       do    
       {   
           if (tfile != NULL)
              fclose(tfile);
           char buf[12];
           sprintf(buf, "RESMAP.%03d", ++cdnumber);
           tfile = fopen(buf, "rb");         
       } while (tfile!=NULL);
    }
if (DEBUGMODE) { //
    printf("\n%d Segments\n",cdnumber-1);
    if (isGK2)
       printf("GK2 fixes activated\n");
    if (deleteafter)
       printf("Delete original files\n");
    if (DEBUGMODE)
       printf("Low Debug mode activated\n");
    if (fileoutput!=NULL)
       printf("Output redirected on Text file\n");
    printf("\nPress Enter to continue...\n");    
    t = getchar();
} //DEBUGMODE    
    int err = loadResMaps(); 
    if (err)
       return err;
if (DEBUGMODE) { //
    printf("\nResource Maps loaded! Press Enter...\n");    
    t = getchar();
} //DEBUGMODE    
    err = loadMap65535(); 
    if (err)
       return err;
if (DEBUGMODE) { //
    printf("\nSfx Maps loaded! Press Enter...\n");       
    t = getchar();
} //DEBUGMODE       
    err = loadAudMaps(); 
    if (err)
       return err;   
if (DEBUGMODE) { //
    printf("\nAudio Maps loaded! Press Enter...\n");       
    t = getchar();
} //DEBUGMODE               
 
    err = buildRESSFX();
    if (err)
       return err;   
if (DEBUGMODE) { //
    printf("\nSFX Map rebuilt! Press Enter...\n");       
    t = getchar();
} //DEBUGMODE    

    err = buildRESAUD();
    if (err)
       return err;   
if (DEBUGMODE) { //
    printf("\nAudio Maps rebuilt! Press Enter...\n");       
    t = getchar();
} //DEBUGMODE   

    err = buildResource();
    if (err)
       return err;   
if (DEBUGMODE) { //  
    printf("\nResource Volume rebuilt! Press Enter...\n");     
    t = getchar();
} //DEBUGMODE  

    if (fileoutput!=NULL)
       fclose(fileoutput);
        
    return 0;
}
