/*  by Enrico Rolfi     */


#pragma once
#pragma pack(1)
 // FORMATO DEI 65535.MAP

typedef struct _MAP65535 {
        unsigned short   soundNumber;         //(es 211.snd)
        unsigned         relOffset:24;           //la grandezza del file precedente
} MAP65535, *PMAP65535;
#define MAP65535SIZE (sizeof(_MAP65535))                                            //   Il primo del file vale 0x000000!!

/*
FFFF
FFFFFF
alla fine, tuple vuote
*/

//  FORMATO DEGLI ALTRI MAP RELATIVI A RESOURCE.AUD

//+00 ulong  start	offset in RES.AUD file where data begins


typedef struct _MAPSAUD {
        unsigned long  audNumber;         //.aud number  and folowing stuff:
        //unsigned char   byte1;             //CHECK: might be byte 2^3 of audnumber
        //unsigned char   byte2;             //CHECK: una specie di contatore dei file relativi allo stesso dialogo (botte e risposte)
        unsigned       relOffset:24;         //la grandezza del file precedente
                                           //Il primo del file vale 0x000000!!
} MAPSAUD, *PMAPSAUD;
#define MAPSAUDSIZE (sizeof(_MAPSAUD)) 

/*
FFFFFFFF
FF
FF
FF
FF
FFFFFF

alla fine, tuple vuote
*/
                                           
struct AUDMAP {
       unsigned short fileNumber;
       unsigned long fileStart;
       PMAPSAUD entry;
       unsigned short entriesCount;
};



#pragma pack()





struct PROGRAMAUDENTRY {
       unsigned long number;
       unsigned long size;
       unsigned char file;
       unsigned long offset;       
};

class ProgramAudMap {
       unsigned short _id;
       List<PROGRAMAUDENTRY> *_list;
public:
       ProgramAudMap(unsigned short myid, unsigned short size) :_id(myid) { _list = new List<PROGRAMAUDENTRY>(size); }
       ~ProgramAudMap() { delete _list; };
       
       unsigned short getAudFileNumber() const { return _id; }
       unsigned short getEntriesCount() const { return _list->getLast(); };
       
       long addAudEntry(PROGRAMAUDENTRY *newEntry, int DebugActive);
       PROGRAMAUDENTRY *getAudEntry(unsigned long number) const;
       PROGRAMAUDENTRY *getAudEntryByNum(unsigned short number) const { _list->getItem(number); } 
       long searchAud(unsigned long number) const;
       
};


PROGRAMAUDENTRY *ProgramAudMap::getAudEntry(unsigned long number) const
{
    return getAudEntryByNum(searchAud(number));

}

long ProgramAudMap::addAudEntry(PROGRAMAUDENTRY *newEntry, int DebugActive)
{
    //ricerca del duplicato eventuale
    long tmpTwinIdx = searchAud(newEntry->number);
    if (tmpTwinIdx>=0)
    {
       unsigned long tmpTwinSize = getAudEntryByNum(tmpTwinIdx)->size;
       if (DebugActive!=0)
       {
          if (DebugActive==2)
             return 1;
          else
          {
              _list->changeItem(tmpTwinIdx, newEntry);
              return tmpTwinSize;  
          }                  
         
       }
       else if (newEntry->size <= tmpTwinSize)
          return 1;
       else
       {
          _list->changeItem(tmpTwinIdx, newEntry);
          return tmpTwinSize;  
       }
    }
   
    if (!_list->addItem(newEntry))
       return -1;
  
    return 0;
}

long ProgramAudMap::searchAud(unsigned long number) const
{   
    PROGRAMAUDENTRY *tempAudPtr; 
    for (unsigned short i=0; i<_list->getLast(); i++)
    {
         tempAudPtr = getAudEntryByNum(i);
         if (!tempAudPtr)   //anche se non dovrebbe mai accadere
            return -2;
         if (tempAudPtr->number == number)
            return (long)i;
    }
     
    return -1;
}


class ListAud: public List<ProgramAudMap*> {
public:
    ListAud(const unsigned short size) : List<ProgramAudMap*>(size) { }

    ProgramAudMap *getAudFile(unsigned short number) const;
    
};

ProgramAudMap *ListAud::getAudFile(unsigned short number) const
{
    for (long i=0; i<getLast(); i++)
        if ((*getItem(i))->getAudFileNumber() == number)
           return *getItem(i);
    
    return 0;
}



struct PROGRAMSFXENTRY {
       unsigned short number;
       unsigned long size;
       unsigned char file;
       unsigned long offset;
       unsigned long replaced;       
};




